#!/bin/sh
#
# Copyright © 2012 Nick Bowler
#
# Randomized tests that libcdecl can parse its own output.
#
# License WTFPL2: Do What The Fuck You Want To Public License, version 2.
# This is free software: you are free to do what the fuck you want to.
# There is NO WARRANTY, to the extent permitted by law.

: "${RANDOMSEED=$RANDOM}" "${TESTITER=100}"

randomdecl=test/randomdecl$EXEEXT
crossparse=test/crossparse$EXEEXT
test -x $randomdecl || exit 77

proc() {
	result=pass
	count=0

	while read decl
	do
		count=`expr $count + 1`
		$crossparse "$decl" || { result=fail; break; }
	done

	echo "result=$result"
	echo "count=$count"
}

printf '%s: randomized test using RANDOMSEED=%d\n' "$0" "$RANDOMSEED"

eval_cmd=`exec 3>&1
	{ $randomdecl -s "$RANDOMSEED" -n "$TESTITER" 3>&-
		echo gen_status=$? >&3
	} | proc >&3`
eval "$eval_cmd"

expected_count=`expr "$TESTITER" + 0`
if test x"$count" != x"$expected_count"; then
	printf '%s: failed after %d successful tests (out of %d)\n' \
		"$0" "$count" "$expected_count" 1>&2
	exit 1
fi

test x"$result" = x"pass" && test x"$gen_status" = x"0" && exit 0
exit 1
